
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>ELK开发部署（1）：安装Elasticsearch组建单服务器多节点集群 / 憋错料</title>

    <meta name="description" content="ELK开发部署（1）：安装Elasticsearch组建单服务器多节点集群 ELK简介 最近有个需求搭建一套日志系统用于集成几个业务系统的日志提供快速的检索功能,目前是用Log4net存数据库+Error级别发邮件方式,也算简单暴力好用,但历史日志的模糊查询确实很慢,所以使用ELK是比较理想的解决方案.三年前写过两篇文章log4net.NoSql +ElasticSearch 实现日志记录和log4net.redis+logstash+kibana+elasticsearch+redis 实现日志系统,感觉有点凌乱,这次借着项目需要重新整理一下.参考ELK不权威指南可以">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">ELK开发部署（1）：安装Elasticsearch组建单服务器多节点集群</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h1>ELK简介</h1>
<p>　　最近有个需求搭建一套日志系统用于集成几个业务系统的日志提供快速的检索功能，目前是用Log4net存数据库+Error级别发邮件方式，也算简单暴力好用，但历史日志的模糊查询确实很慢，所以使用ELK是比较理想的解决方案。三年前写过两篇文章<a href="http://www.cnblogs.com/zhaobl/p/ElasticSearch_log4net_nosql.html" rel="external nofollow noreferrer">log4net.NoSql +ElasticSearch 实现日志记录</a>和<a href="http://www.cnblogs.com/zhaobl/p/log4net_redis.html" rel="external nofollow noreferrer">log4net.redis+logstash+kibana+elasticsearch+redis 实现日志系统</a>，感觉有点凌乱，这次借着项目需要重新整理一下。参考<a href="https://zhuanlan.zhihu.com/p/22400290" rel="external nofollow noreferrer">ELK不权威指南</a>可以对ELK做个大体了解它的应用场景和优缺点，总之&ldquo;ELK 三个字母分别是三个软件产品的缩写。 E代表Elasticsearch,负责日志的存储和检索； L代表Logstash, 负责日志的收集，过滤和格式化；K代表Kibana，负责日志的展示统计和数据可视化。&rdquo;。以前常见的ELK架构如下：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzkwMzY0Ni8yMDE3MDcvOTAzNjQ2LTIwMTcwNzA1MTUyODU0ODYyLTI5Nzc4NjY2NS5wbmc=.jpg" /></p>
<p>现在官方的推荐架构是<a href="https://www.elastic.co/cn/products" rel="external nofollow noreferrer">https://www.elastic.co/cn/products</a></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzkwMzY0Ni8yMDE3MDcvOTAzNjQ2LTIwMTcwNzA1MTUzMDMyMTc1LTI1NzQ1OTY0My5wbmc=.jpg" /></p>
<p>就像知乎上说的Elasticsearch是ELK的核心，&nbsp;L和K都有相应的替代方案(日记采集可以不使用Logstash，而是直接使用<strong><a href="https://github.com/ernestomerino/log4net.NoSql" rel="external nofollow noreferrer">log4net.nosql</a></strong>输出到ES，或者像我那样自己写个<a href="http://download.csdn.net/detail/zbl131/7702673" rel="external nofollow noreferrer">log4net.redis</a>输出到redis),所以先从Elasticsearch开始。</p>
<h1>环境说明</h1>
<p>1. windows server 2012 R2 64位</p>
<p>2.&nbsp;jdk-8u131-windows-x64.exe</p>
<p>3.&nbsp;elasticsearch-5.4.0.zip</p>
<h1>Elasticsearch 安装</h1>
<h2>1. &nbsp;下载Elasticsearch</h2>
<p>　　打开官网&nbsp;https://www.elastic.co/downloads/elasticsearch&nbsp;，目前最新版本是5.4.3，下载Zip格式文件，解压到E:\elk\elasticsearch，路径不要包括中文。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzkwMzY0Ni8yMDE3MDcvOTAzNjQ2LTIwMTcwNzA1MTYzMDA3OTg3LTIxMDAwODc3Ny5wbmc=.jpg" /></p>
<h2>2. 从命令行运行Elasticsearch</h2>
<p>命令行下到bin目录，运行elasticsearch.bat，出现如下界面表示服务起来了（不代表成功）。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzkwMzY0Ni8yMDE3MDcvOTAzNjQ2LTIwMTcwNzA1MTkzNTQxMTc1LTExOTM1NTE0NjAucG5n.jpg" /></p>
<p>在IE浏览器里输入 http://localhost:9200,弹出一个json文件下载内容如下表示成功了：</p>
<pre>{
  "name" : "KaeR6Q2",
  "cluster_name" : "elasticsearch",
  "cluster_uuid" : "S4uOl5YERqaq1NBk9wId-g",
  "version" : {
    "number" : "5.4.0",
    "build_hash" : "780f8c4",
    "build_date" : "2017-04-28T17:43:27.229Z",
    "build_snapshot" : false,
    "lucene_version" : "6.5.0"
  },
  "tagline" : "You Know, for Search"
}</pre>
<p>按ctrl+c停止服务。</p>
<p>如果输入&nbsp;http://localhost:9200 报错，使用netstat -anp tcp 还可以看到9200、9300端口都在监听了，那么就看一下命令行输出里是否有乱码，如下图：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzkwMzY0Ni8yMDE3MDcvOTAzNjQ2LTIwMTcwNzA1MTkzMTM2NTk3LTg0NTA3MjQzLnBuZw==.jpg" /></p>
<p>在E:\elk\elasticsearch\logs\elasticsearch.log里可以看到日志</p>
<blockquote><p>[2017-07-05T17:48:07,373][INFO ][o.e.n.Node ] [] initializing ...<br />[2017-07-05T17:48:07,811][INFO ][o.e.e.NodeEnvironment    ] [KaeR6Q2] using [1] data paths, mounts [[新加卷 (E:)]], net usable_space [98.2gb], net total_space [99.9gb], spins? [unknown], types [NTFS]<br />[2017-07-05T17:48:07,826][INFO ][o.e.e.NodeEnvironment    ] [KaeR6Q2] heap size [1.9gb], compressed ordinary object pointers [true]</p></blockquote>
<p>右键查看磁盘属性把卷标&ldquo;新加卷&rdquo;去掉就可以了。</p>
<h2>3. 配置Elasticsearch</h2>
<p>　　Elasticsearch从config\elasticsearch.yml文件加载默认配置，也可以在命令行里用-E前缀指定，比如：</p>
<pre>elasticsearch.bat -Ecluster.name=myCluster -Enode.name=myNode</pre>
<p>　　访问http://localhost:9200,返回值：</p>
<pre>{
  "name" : "myNode",
  "cluster_name" : "myCluster",
  "cluster_uuid" : "S4uOl5YERqaq1NBk9wId-g",
  "version" : {
    "number" : "5.4.0",
    "build_hash" : "780f8c4",
    "build_date" : "2017-04-28T17:43:27.229Z",
    "build_snapshot" : false,
    "lucene_version" : "6.5.0"
  },
  "tagline" : "You Know, for Search"
}</pre>
<p>修改elasticsearch.yml文件实现配置，格式说明<em><a href="https://www.elastic.co/guide/en/elasticsearch/reference/current/settings.html" rel="external nofollow noreferrer">Configuring Elasticsearch</a>，</em></p>
<pre># Use a descriptive name for your cluster:
#
cluster.name: esLogCluster

# Use a descriptive name for the node:
#
node.name: esLogNode_175

# Set the bind address to a specific IP (IPv4 or IPv6):
#
network.host: 192.168.5.175</pre>
<p>再次运行elasticsearch.bat，就可以使用ip地址远程访问了。</p>
<h2>4. 安装Elasticsearch服务elasticsearch-master</h2>
<p>　　elasticsearch可以后台服务的方式运行，通过elasticsearch-service.bat脚本安装、卸载、启动、停止、管理服务，参数说明如下：</p>
<table>
<tbody>
<tr>
<td>
<br /><code>install</code></p>
</td>
<td>
<br />Install Elasticsearch as a service</p>
</td>
</tr>
<tr>
<td>
<br /><code>remove</code></p>
</td>
<td>
<br />Remove the installed Elasticsearch service (and stop the service if started)</p>
</td>
</tr>
<tr>
<td>
<br /><code>start</code></p>
</td>
<td>
<br />Start the Elasticsearch service (if installed)</p>
</td>
</tr>
<tr>
<td>
<br /><code>stop</code></p>
</td>
<td>
<br />Stop the Elasticsearch service (if started)</p>
</td>
</tr>
<tr>
<td>
<br /><code>manager</code></p>
</td>
<td>
<br />Start a GUI for managing the installed service</p>
</td>
</tr>
</tbody>
</table>
<p>参数后面可以跟一个可选参数 service_id,用于指定服务名称，默认的名称是 elasticsearch-service-x64，安装服务：</p>
<pre>elasticsearch-service install elasticsearch-master</pre>

<pre>配置服务：</pre>

<pre>elasticsearch-service manager elasticsearch-master</pre>

<pre></pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzkwMzY0Ni8yMDE3MDcvOTAzNjQ2LTIwMTcwNzA2MTMzNTEzOTg3LTgxODM0MTU5LnBuZw==.jpg" /></p>
<p>注意修改启动类型为自启动，java初始内存（默认是2G）可以调小一些。</p>
<h2>5. 安装Elasticsearch服务elasticsearch-slave,组成单服务器多节点集群</h2>
<p>　　a.复制E:\elk\elasticsearch文件夹重命名为E:\elk\elasticsearch-slave</p>
<p>　　 b.删除E:\elk\elasticsearch-slave\data文件夹下的内容，切记一定要删除</p>
<p>　　c.修改E:\elk\elasticsearch-slave\config\elasticsearch.yml文件</p>
<pre>node.name: esLogNode_175_slave

node.master: false

discovery.zen.ping.unicast.hosts: ["192.168.5.175"] </pre>

<pre>  d.安装服务</pre>

<pre>elasticsearch-service install elasticsearch-slave</pre>
<p>　　e.验证集群，输入http://192.168.5.175:9200/_cluster/health?pretty，number_of_nodes和number_of_data_nodes等于2表示成功。</p>
<pre>{
  "cluster_name" : "esLogCluster",
  "status" : "green",
  "timed_out" : false,
  "number_of_nodes" : 2,
  "number_of_data_nodes" : 2,
  "active_primary_shards" : 0,
  "active_shards" : 0,
  "relocating_shards" : 0,
  "initializing_shards" : 0,
  "unassigned_shards" : 0,
  "delayed_unassigned_shards" : 0,
  "number_of_pending_tasks" : 0,
  "number_of_in_flight_fetch" : 0,
  "task_max_waiting_in_queue_millis" : 0,
  "active_shards_percent_as_number" : 100.0
}</pre>

<h1>踩坑总结</h1>
<p>1. 磁盘卷标是中文，端口监听了通过http://localhost:9200访问失败</p>
<p>2. 组建集群时复制elasticsearch文件夹没有清空data里的内容，出现错误&ldquo;found existing node {node-1}{vP19PMOyT2ilJKRAqgn78w}{jDULCExERXGHp4VXpbyuJA}{127.0.0.1}{127.0.0.1:9300} with the same id but is a different node instance]&rdquo;</p>
<h1>参考链接</h1>
<p>1.<a href="https://www.elastic.co/guide/en/elasticsearch/reference/current/windows.html" rel="external nofollow noreferrer">Install Elasticsearch on Windows</a>，官方文档</p>
<p>2.<a href="http://www.cnblogs.com/wxw16/p/6150681.html" rel="external nofollow noreferrer">ElasticSearch 5学习(1)&mdash;&mdash;安装Elasticsearch、Kibana和X-Pack</a>&nbsp;Linux环境教程</p>
<p>3.<a href="https://zhuanlan.zhihu.com/p/22400290" rel="external nofollow noreferrer">ELK不权威指南</a></p>
<p>4.<a href="http://www.cnblogs.com/alex-note/p/6951004.html" rel="external nofollow noreferrer">ELK介绍</a></p>
<p>5.<a href="https://www.zybuluo.com/muyanfeixiang/note/608470" rel="external nofollow noreferrer">ELK+FileBeat+Log4Net搭建日志系统</a></p>
<p>6.<a href="http://www.cnblogs.com/alex-note/p/6952178.html" rel="external nofollow noreferrer">Elk 进阶部署</a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-15 11:17:21 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/pat/" title="pat">pat</a>, <a href="https://www.biecuoliao.com/tag/int/" title="int">int</a>, <a href="https://www.biecuoliao.com/tag/nbsp/" title="nbsp">nbsp</a>, <a href="https://www.biecuoliao.com/tag/sed/" title="sed">sed</a>, <a href="https://www.biecuoliao.com/tag/%e4%bb%a4%e8%a1%8c/" title="令行">令行</a>, <a href="https://www.biecuoliao.com/tag/tps/" title="tps">tps</a>, <a href="https://www.biecuoliao.com/tag/uid/" title="uid">uid</a>, <a href="https://www.biecuoliao.com/tag/ping/" title="ping">ping</a>, <a href="https://www.biecuoliao.com/tag/%e8%bf%87%e6%bb%a4/" title="过滤">过滤</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>ELK开发部署（1）：安装Elasticsearch组建单服务器多节点集群的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPx9bmM.html" rel="bookmark">ELK日志框架（1）：安装Elasticsearch组建单服务器多节点集群</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:ELK日志框架(1):安装Elasticsearch组建单服务器多节点集群 ELK简介 最近有个需求搭建一套日志系统用于集成几个业务系统的日志提供快速的检索功能,目前是用Log4net存数据库+Error级别发邮件方式,也算简单暴力好用,但历史日志的模糊查询确实很慢,所以使用ELK是比较理想的解决方案.三年前写过两篇文章log4net.NoSql +ElasticSearch 实现日志记录和log4net.redis+logstash+kibana+elasticsearch+redis			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Myr75Y0.html" rel="bookmark">&period;net core 与ELK（2）安装Elasticsearch可视化工具</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				elasticsearch-head是els的界面插件,地址https://github.com/mobz/elasticsearch-head 1.进入github并下载 wget https://github.com/mobz/elasticsearch-head/archive/master.zip 2.解压 [[email protected] /usr/local/src]# unzip master.zip [[email protected] /usr/local/src]# mv			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MVGkgp0.html" rel="bookmark">Kubernetes群集之：二进制部署单etcd，多节点集群</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Kubernetes集群部署 1.官方提供的三种部署方式2.Kubernetes平台环境规划3.自签SSL证书4.Etcd数据库群集部署 5.Node安装Docker6.Flannel容器集群网络部署7.部署Master组件8.部署Node组件9.部署一个测试示例10.部署Web UI(Dashboard)11.部署集群内部DNS解析服务(CoreDNS) 官方提供的三种部署方式: minikube: Minikube是一个工具,可以在本地快速运行单点的Kubernetes,仅用于尝试Kuber			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0dlgR90.html" rel="bookmark">kubeadm搭建kubernetes（v1&period;13&period;1）单节点集群</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				kubeadm是Kubernetes官方提供的用于快速部署Kubernetes集群的工具,本篇文章使用kubeadm搭建一个单master节点的k8s集群. 节点部署信息 节点主机名 节点IP 节点角色 操作系统 k8s-master 10.10.55.113 master centos7.6 k8s-node1 10.10.55.114 node centos7.6 节点说明 master:控制节点.kube-apiserver负责API服务,kube-controller-manager负责			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0a6lVE3.html" rel="bookmark">Hadoop学习笔记（二）设置单节点集群</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文描述如何设置一个单一节点的 Hadoop 安装,以便您可以快速执行简单的操作,使用 Hadoop MapReduce 和 Hadoop 分布式文件系统 (HDFS). 参考官方文档:Hadoop MapReduce Next Generation - Setting up a Single Node Cluster. Hadoop版本:Apache Hadoop 2.5.1 系统版本:CentOS 6.5,内核(uname -r):2.6.32-431.el6.x86_64 系统必备组件 支			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35YOmE3.html" rel="bookmark">Hadoop学习笔记（两）设置单节点集群</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文描写叙述怎样设置一个单一节点的 Hadoop 安装.以便您能够高速运行简单的操作,使用 Hadoop MapReduce 和 Hadoop 分布式文件系统 (HDFS). 參考官方文档:Hadoop MapReduce Next Generation - Setting up a Single Node Cluster. Hadoop版本号:Apache Hadoop 2.5.1 系统版本号:CentOS 6.5.内核(uname -r):2.6.32-431.el6.x86_64 系统必备			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3qNwyW4.html" rel="bookmark">redis单节点集群</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.概念 redis是一种支持Key-Value等多种数据结构的存储系统.可用于缓存.事件发布或订阅.高速队列等场景.该数据库使用ANSI C语言编写,支持网络,提供字符串.哈希.列表.队列.集合结构直接存取,基于内存,可持久化. 二.redis的应用场景有哪些 1.会话缓存(最常用) 2.消息队列,比如支付 3.活动排行榜或计数 4.发布.订阅消息(消息通知) 5.商品列表.评论列表等 1.redis安装: # wget http://download.redis.io/releases/re			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/D3OmzGM.html" rel="bookmark">ELK学习笔记（一）安装Elasticsearch、Kibana、Logstash和X-Pack</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近在学习ELK的时候踩了不少的坑,特此写个笔记记录下学习过程. 日志主要包括系统日志.应用程序日志和安全日志.系统运维和开发人员可以通过日志了解服务器软硬件信息.检查配置过程中的错误及错误发生的原因.经常分析日志可以了解服务器的负荷,性能安全性,从而及时采取措施纠正错误. 通常,日志被分散的储存不同的设备上.如果你管理数十上百台服务器,你还在使用依次登录每台机器的传统方法查阅日志.这样是不是感觉很繁琐和效率低下.当务之急我们使用集中化的日志管理,例如:开源的syslog,将所有服务器上的日志收			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0aZOKk3.html" rel="bookmark">ELK环境的部署与安装</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ELK简介 Elasticsearch:是一个高度可扩展的开源全文搜索和分析引擎.能够快速,实时的存储,搜索和分析大量数据,通常用做底层引擎技术. Kibana:是一个开源分析和可视化平台,是进入Elastic Stack的窗口,可以在Elasticsearch中对程序的数据进行可视化探索和实时分析,旨在与Elasticsearch协同工作. 使用Kibana搜索,查看和与存储在Elasticsearch索引中的数据进行交互,可以轻松执行数据分析,并在各种表格,图标和地图中查看数据,基于浏览器的			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/n3ZyQG0.html" rel="bookmark" class="title">python读写操作文件</a>
					<div>
						with open(xxx,'r,coding='utf-8') as f:   #打开文件赋值给F ,并且执行完了之后不需要 f.close(). 在Python 2.7 及以后,with又支持同时 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBm88Y4.html" rel="bookmark" class="title">SketchUp与ArcScene之间的数据交流</a>
					<div>
						经常做三维建模的都知道原来SketchUp与ArcGIS之间的数据交流是有一个小插件的叫做SketchUp Esri,它可以将ArcGIS中的数据导出为SketchUp可以处理的数据,然后再Skech ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nvwAp0.html" rel="bookmark" class="title">运动函数move 各种各样的运动都可以做</a>
					<div>
						在这里我说的还是那种匀速运动,主要是通过改变一个盒模形的left值和top 值,来实现运动,或者,改变模形的自身的属性,来动起来: function getStyle(obj,name){ retur ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rEY5v0.html" rel="bookmark" class="title">历年学生软件作品点评</a>
					<div>
						1.抢答器 这是东北师范大学的杨老师学生耐撕团队设计的一个抢答器 Coding地址:https://coding.net/u/zhengrui0452/p/QiangDaQi/git/tree/mas ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgPeN80.html" rel="bookmark" class="title">python对json的相关操作</a>
					<div>
						什么是json: JSON(JavaScript Object Notation) 是一种轻量级的数据交换格式.易于人阅读和编写.同时也易于机器解析和生成.它基于JavaScript Programm ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGawjo3.html" rel="bookmark" class="title">loadrunner-事务</a>
					<div>
						自从安装了loadrunner之后,就没怎么用过它了,项目之前也没做过性能测试,所以学习起来比较困难,而且性能测试远远不止使用工具这么简单.下面介绍一下最近学习的loadrunner添加事务. 事务是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ey2Lw0.html" rel="bookmark" class="title">如何使用函数公式来查找图片</a>
					<div>
						先看效果: 是不是有点意思啊.好,咱们看看如何实现这样的效果. 步骤一: 准备好图片资料,话说巧媳妇难做无米之炊,没有资料,如何查询?如下图所示:A列是产品名称,B列是对应的图片.注意图片的大小要在单 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47mRBo0.html" rel="bookmark" class="title">JavaScript之字符串匹配工具&lbrack;插件&rsqb;</a>
					<div>
						/*** * StringCheckUtil * 字符串检测工具 * * @version 1.0 * @method isNum(string,scope) * @method isChinese( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kZJ57M.html" rel="bookmark" class="title">动态获取导航栏</a>
					<div>
						这里记录的是两层的导航栏.首先数据库中建两张表,一张存储父节点数据,另一张存储子节点数据,结构如下 父表: 子表: 这里有两种方式实现导航栏.第一种,通过两个Repeater循环得到并展示导航栏.第二 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0leOPN3.html" rel="bookmark" class="title">Analyzer报表里显示的 &ast; 星号、红叉、&num;井号的意义</a>
					<div>
						声明:原创作品,转载时请注明文章来自SAP师太技术博客( 博/客/园www.cnblogs.com):www.cnblogs.com/jiangzhengjun,并以超链接形式标明文章原始出处,否则将 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41oZ1o0.html" rel="bookmark" class="title">C&plus;&plus;必知必会（6）</a>
					<div>
						条款55模板的模板参数 见一下stack适配器采用默认Deque的例子 template&lt;typename T, class Cont =Deque&lt;T&gt;&gt; class Sta ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nLK1p4.html" rel="bookmark" class="title">HDU 4777 Rabbit Kingdom --容斥原理&plus;树状数组</a>
					<div>
						题意: 给一个数的序列,询问一些区间,问区间内与区间其他所有的数都互质的数有多少个. 解法: 直接搞有点难, 所谓正难则反,我们求区间内与其他随便某个数不互质的数有多少个,然后区间长度减去它就是答案了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l7dxLM.html" rel="bookmark" class="title">10分钟英语史</a>
					<div>
						----------------------- 钦定版&lt;圣经&gt; ----------------------- chapter 4The King James Bible or light ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qRW954.html" rel="bookmark" class="title">cacti监控模板华为s5700l-s7703-usg防火墙</a>
					<div>
						cacti监控模板华为s5700l-s7703-usg防火墙 ,下载地址: http://down.51cto.com/data/2290169					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLRPQO3.html" rel="bookmark" class="title">Python全栈--9&period;1--面向对象进阶-super 类对象成员--类属性- 私有属性 查找源码类对象步骤 类特殊成员 isinstance issubclass 异常处理</a>
					<div>
						上一篇文章介绍了面向对象基本知识: 面向对象是一种编程方式,此编程方式的实现是基于对 类 和 对象 的使用 类 是一个模板,模板中包装了多个“函数”供使用(可以讲多函数中公用的变量封装到对象中) 对象 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AWWPv0.html" rel="bookmark" class="title">5、RabbitMQ - Exchange之 fanout &bsol; 【direct 关键字发送】 &bsol; topic</a>
					<div>
						pytho系列之 RabbitMQ - Exchange几种模式 RabbitMQ中,所有生产者提交的消息都由Exchange来接受,然后Exchange按照特定的策略转发到Queue进行存储 Rab ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49v59JM.html" rel="bookmark" class="title">golang测试StringBuilder</a>
					<div>
						1 package main 2 3 import ( 4 &quot;fmt&quot; 5 &quot;git.oschina.net/ha666/golibs&quot; 6 &quot;tim ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDnr2o3.html" rel="bookmark" class="title">几何画板做圆柱的方法有哪些</a>
					<div>
						很多老师在教学过程中不仅会涉及到平面图形,也会涉及到立体图形.圆柱就属于立体几何图形,它是以矩形的一边所在直线为旋转轴,其余三边旋转360°形成的曲面所围成的几何体.很多的老师都在用几何画板辅助教程, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBDYQY3.html" rel="bookmark" class="title">JSP 原理</a>
					<div>
						1.JSP的由来 在JSP出现之前.为了实现动态网页的效果,server端利用 Servlet 的输出流向client发送HTML标签以及HTML页面中的内容,可是在多数动态网页中,绝大部分内容是静态 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lLLRB0.html" rel="bookmark" class="title">深入理解指针函数</a>
					<div>
						文章来自http://blog.sina.com.cn/s/blog_5e8facd20100qn20.html 1.指针函数的定义 顾名思义,指针函数即返回指针的函数.其一般定义形式如下: 类型名  ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.026 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
